



class cls_ConfigurationFile{
private:
  char Filename[32];
public:
  cls_ConfigurationFile();
  void LoadProfileSettings();
  void SaveProfileSettings();
};

cls_ConfigurationFile::cls_ConfigurationFile(){
  strcpy(Filename,"./profile/.conf1");
}

void cls_ConfigurationFile::SaveProfileSettings(){
  FILE *fp;
  if( (fp = fopen(Filename,"w")) == NULL )
    return;

  fprintf(fp,"CONFIGURATION FILE CREATED BY Activated Core\n");
  fprintf(fp,"============================================\n");
  fprintf(fp,"DO NOT EDIT THIS FILE IF YOU DON\'T KNOW WHAT\n");
  fprintf(fp,"  STUFF IS. IF SOMETHING GOES WRONG EDITING \n");
  fprintf(fp," REMOVE THE FILE AND RESTART  Activated Core\n");
  fprintf(fp,"       TO RE-GENERATE DEFAULT SETTINGS!     \n");
  fprintf(fp,"============================================\n");

  // Start to write settings:

  fprintf(fp,"[NUMOPTS] 3\n");

  fprintf(fp,"[NAME] %s\n",Player.GetName());

  fprintf(fp,"[FULLSCREEN] %i\n",AC.GetFullscreen());
  fprintf(fp,"[MODE] %i %i\n",AC.GetResolution(0),AC.GetAspectRatio(0));

  fclose(fp);
  
}


void cls_ConfigurationFile::LoadProfileSettings(){
  FILE *fp;
  if( (fp = fopen(Filename,"r")) == NULL ){
    printf("Can't find Profile Settings File\n  %s",Filename);
    SaveProfileSettings();
    return;
  }
    

  char tmp[256];
  int tmpi,tmpj;
  
  char tag[32];

  fseek(fp,314,SEEK_SET);

  // Start to load settings:
  int no = 0;
  if(fscanf(fp,"%s %i",tmp,&no) <= 0)
    return;
//  printf("Will load %i settings (%s)\n",no, tmp);

  int i;
  for( i = 0; i < no; i++ ){
    if(fscanf(fp,"%s",tag) <= 0)
      break;
//    printf("Loading %s\n",tag);
    if( strcmp(tag,"[NAME]") == 0 ){
      if(fscanf(fp,"%s",tmp) <= 0)
        break;
      Player.SetName(tmp);
    } else if( strcmp(tag,"[FULLSCREEN]") == 0 ){
      if(fscanf(fp,"%i",&tmpi) <= 0)
        break;
      if( tmpi ){
        AC.SetFullscreen();
      } else {
        AC.SetWindowed();
      }
    } else if( strcmp(tag,"[MODE]") == 0 ){
      if(fscanf(fp,"%i %i",&tmpi,&tmpj) <= 0)
        break;
      AC.SetResolution(tmpi,tmpj);
    }
  }

  fclose(fp);

}




cls_ConfigurationFile Profile;